"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.LemmyHttp = exports.LemmyHttpError = void 0;
var class_transformer_1 = require("class-transformer");
var comment_1 = require("./interfaces/api/comment");
var community_1 = require("./interfaces/api/community");
var person_1 = require("./interfaces/api/person");
var post_1 = require("./interfaces/api/post");
var site_1 = require("./interfaces/api/site");
var others_1 = require("./interfaces/others");
var HttpType;
(function (HttpType) {
    HttpType["Get"] = "GET";
    HttpType["Post"] = "POST";
    HttpType["Put"] = "PUT";
})(HttpType || (HttpType = {}));
var LemmyHttpError = /** @class */ (function (_super) {
    __extends(LemmyHttpError, _super);
    function LemmyHttpError() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    return LemmyHttpError;
}(Error));
exports.LemmyHttpError = LemmyHttpError;
/**
 * Helps build lemmy HTTP requests.
 */
var LemmyHttp = /** @class */ (function () {
    /**
     * Generates a new instance of LemmyHttp.
     * @param baseUrl the base url, without the vX version: https://lemmy.ml -> goes to https://lemmy.ml/api/vX
     * @param headers optional headers. Should contain `x-real-ip` and `x-forwarded-for` .
     */
    function LemmyHttp(baseUrl, headers) {
        this.headers = {};
        this.apiUrl = "".concat(baseUrl, "/api/").concat(others_1.VERSION);
        if (headers) {
            this.headers = headers;
        }
    }
    /**
     * Gets the site, and your user data.
     *
     * `HTTP.GET /site`
     */
    LemmyHttp.prototype.getSite = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Get, "/site", form, site_1.GetSiteResponse)];
            });
        });
    };
    /**
     * Create your site.
     *
     * `HTTP.POST /site`
     */
    LemmyHttp.prototype.createSite = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Post, "/site", form, site_1.SiteResponse)];
            });
        });
    };
    /**
     * Edit your site.
     *
     * `HTTP.PUT /site`
     */
    LemmyHttp.prototype.editSite = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Put, "/site", form, site_1.SiteResponse)];
            });
        });
    };
    /**
     * Leave the Site admins.
     *
     * `HTTP.POST /user/leave_admin`
     */
    LemmyHttp.prototype.leaveAdmin = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Post, "/user/leave_admin", form, site_1.GetSiteResponse)];
            });
        });
    };
    /**
     * Get the modlog.
     *
     * `HTTP.GET /modlog`
     */
    LemmyHttp.prototype.getModlog = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Get, "/modlog", form, site_1.GetModlogResponse)];
            });
        });
    };
    /**
     * Search lemmy.
     *
     * `HTTP.GET /search`
     */
    LemmyHttp.prototype.search = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Get, "/search", form, site_1.SearchResponse)];
            });
        });
    };
    /**
     * Fetch a non-local / federated object.
     *
     * `HTTP.GET /resolve_object`
     */
    LemmyHttp.prototype.resolveObject = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Get, "/resolve_object", form, site_1.ResolveObjectResponse)];
            });
        });
    };
    /**
     * Create a new community.
     *
     * `HTTP.POST /community`
     */
    LemmyHttp.prototype.createCommunity = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Post, "/community", form, community_1.CommunityResponse)];
            });
        });
    };
    /**
     * Get / fetch a community.
     *
     * `HTTP.GET /community`
     */
    LemmyHttp.prototype.getCommunity = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Get, "/community", form, community_1.GetCommunityResponse)];
            });
        });
    };
    /**
     * Edit a community.
     *
     * `HTTP.PUT /community`
     */
    LemmyHttp.prototype.editCommunity = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Put, "/community", form, community_1.CommunityResponse)];
            });
        });
    };
    /**
     * List communities, with various filters.
     *
     * `HTTP.GET /community/list`
     */
    LemmyHttp.prototype.listCommunities = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Get, "/community/list", form, community_1.ListCommunitiesResponse)];
            });
        });
    };
    /**
     * Follow / subscribe to a community.
     *
     * `HTTP.POST /community/follow`
     */
    LemmyHttp.prototype.followCommunity = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Post, "/community/follow", form, community_1.CommunityResponse)];
            });
        });
    };
    /**
     * Block a community.
     *
     * `HTTP.POST /community/block`
     */
    LemmyHttp.prototype.blockCommunity = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Post, "/community/block", form, community_1.BlockCommunityResponse)];
            });
        });
    };
    /**
     * Delete a community.
     *
     * `HTTP.POST /community/delete`
     */
    LemmyHttp.prototype.deleteCommunity = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Post, "/community/delete", form, community_1.CommunityResponse)];
            });
        });
    };
    /**
     * A moderator remove for a community.
     *
     * `HTTP.POST /community/remove`
     */
    LemmyHttp.prototype.removeCommunity = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Post, "/community/remove", form, community_1.CommunityResponse)];
            });
        });
    };
    /**
     * Transfer your community to an existing moderator.
     *
     * `HTTP.POST /community/transfer`
     */
    LemmyHttp.prototype.transferCommunity = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Post, "/community/transfer", form, community_1.GetCommunityResponse)];
            });
        });
    };
    /**
     * Ban a user from a community.
     *
     * `HTTP.POST /community/ban_user`
     */
    LemmyHttp.prototype.banFromCommunity = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Post, "/community/ban_user", form, community_1.BanFromCommunityResponse)];
            });
        });
    };
    /**
     * Add a moderator to your community.
     *
     * `HTTP.POST /community/mod`
     */
    LemmyHttp.prototype.addModToCommunity = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Post, "/community/mod", form, community_1.AddModToCommunityResponse)];
            });
        });
    };
    /**
     * Create a post.
     *
     * `HTTP.POST /post`
     */
    LemmyHttp.prototype.createPost = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Post, "/post", form, post_1.PostResponse)];
            });
        });
    };
    /**
     * Get / fetch a post.
     *
     * `HTTP.GET /post`
     */
    LemmyHttp.prototype.getPost = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Get, "/post", form, post_1.GetPostResponse)];
            });
        });
    };
    /**
     * Edit a post.
     *
     * `HTTP.PUT /post`
     */
    LemmyHttp.prototype.editPost = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Put, "/post", form, post_1.PostResponse)];
            });
        });
    };
    /**
     * Delete a post.
     *
     * `HTTP.POST /post/delete`
     */
    LemmyHttp.prototype.deletePost = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Post, "/post/delete", form, post_1.PostResponse)];
            });
        });
    };
    /**
     * A moderator remove for a post.
     *
     * `HTTP.POST /post/remove`
     */
    LemmyHttp.prototype.removePost = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Post, "/post/remove", form, post_1.PostResponse)];
            });
        });
    };
    /**
     * Mark a post as read.
     *
     * `HTTP.POST /post/mark_as_read`
     */
    LemmyHttp.prototype.markPostAsRead = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Post, "/post/mark_as_read", form, post_1.PostResponse)];
            });
        });
    };
    /**
     * A moderator can lock a post ( IE disable new comments ).
     *
     * `HTTP.POST /post/lock`
     */
    LemmyHttp.prototype.lockPost = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Post, "/post/lock", form, post_1.PostResponse)];
            });
        });
    };
    /**
     * A moderator can sticky a post ( IE stick it to the top of a community ).
     *
     * `HTTP.POST /post/sticky`
     */
    LemmyHttp.prototype.stickyPost = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Post, "/post/sticky", form, post_1.PostResponse)];
            });
        });
    };
    /**
     * Get / fetch posts, with various filters.
     *
     * `HTTP.GET /post/list`
     */
    LemmyHttp.prototype.getPosts = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Get, "/post/list", form, post_1.GetPostsResponse)];
            });
        });
    };
    /**
     * Like / vote on a post.
     *
     * `HTTP.POST /post/like`
     */
    LemmyHttp.prototype.likePost = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Post, "/post/like", form, post_1.PostResponse)];
            });
        });
    };
    /**
     * Save a post.
     *
     * `HTTP.PUT /post/save`
     */
    LemmyHttp.prototype.savePost = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Put, "/post/save", form, post_1.PostResponse)];
            });
        });
    };
    /**
     * Report a post.
     *
     * `HTTP.POST /post/report`
     */
    LemmyHttp.prototype.createPostReport = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Post, "/post/report", form, post_1.PostReportResponse)];
            });
        });
    };
    /**
     * Resolve a post report. Only a mod can do this.
     *
     * `HTTP.PUT /post/report/resolve`
     */
    LemmyHttp.prototype.resolvePostReport = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Put, "/post/report/resolve", form, post_1.PostReportResponse)];
            });
        });
    };
    /**
     * List post reports.
     *
     * `HTTP.GET /post/report/list`
     */
    LemmyHttp.prototype.listPostReports = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Get, "/post/report/list", form, post_1.ListPostReportsResponse)];
            });
        });
    };
    /**
     * Fetch metadata for any given site.
     *
     * `HTTP.GET /post/site_metadata`
     */
    LemmyHttp.prototype.getSiteMetadata = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Get, "/post/site_metadata", form, post_1.GetSiteMetadataResponse)];
            });
        });
    };
    /**
     * Create a comment.
     *
     * `HTTP.POST /comment`
     */
    LemmyHttp.prototype.createComment = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Post, "/comment", form, comment_1.CommentResponse)];
            });
        });
    };
    /**
     * Edit a comment.
     *
     * `HTTP.PUT /comment`
     */
    LemmyHttp.prototype.editComment = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Put, "/comment", form, comment_1.CommentResponse)];
            });
        });
    };
    /**
     * Delete a comment.
     *
     * `HTTP.POST /comment/delete`
     */
    LemmyHttp.prototype.deleteComment = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Post, "/comment/delete", form, comment_1.CommentResponse)];
            });
        });
    };
    /**
     * A moderator remove for a comment.
     *
     * `HTTP.POST /comment/remove`
     */
    LemmyHttp.prototype.removeComment = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Post, "/comment/remove", form, comment_1.CommentResponse)];
            });
        });
    };
    /**
     * Mark a comment as read.
     *
     * `HTTP.POST /comment/mark_as_read`
     */
    LemmyHttp.prototype.markCommentReplyAsRead = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Post, "/comment/mark_as_read", form, comment_1.CommentResponse)];
            });
        });
    };
    /**
     * Like / vote on a comment.
     *
     * `HTTP.POST /comment/like`
     */
    LemmyHttp.prototype.likeComment = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Post, "/comment/like", form, comment_1.CommentResponse)];
            });
        });
    };
    /**
     * Save a comment.
     *
     * `HTTP.PUT /comment/save`
     */
    LemmyHttp.prototype.saveComment = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Put, "/comment/save", form, comment_1.CommentResponse)];
            });
        });
    };
    /**
     * Get / fetch comments.
     *
     * `HTTP.GET /comment/list`
     */
    LemmyHttp.prototype.getComments = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Get, "/comment/list", form, comment_1.GetCommentsResponse)];
            });
        });
    };
    /**
     * Report a comment.
     *
     * `HTTP.POST /comment/report`
     */
    LemmyHttp.prototype.createCommentReport = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Post, "/comment/report", form, comment_1.CommentReportResponse)];
            });
        });
    };
    /**
     * Resolve a comment report. Only a mod can do this.
     *
     * `HTTP.PUT /comment/report/resolve`
     */
    LemmyHttp.prototype.resolveCommentReport = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Put, "/comment/report/resolve", form, comment_1.CommentReportResponse)];
            });
        });
    };
    /**
     * List comment reports.
     *
     * `HTTP.GET /comment/report/list`
     */
    LemmyHttp.prototype.listCommentReports = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Get, "/comment/report/list", form, comment_1.ListCommentReportsResponse)];
            });
        });
    };
    /**
     * Get / fetch private messages.
     *
     * `HTTP.GET /private_message/list`
     */
    LemmyHttp.prototype.getPrivateMessages = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Get, "/private_message/list", form, person_1.PrivateMessagesResponse)];
            });
        });
    };
    /**
     * Create a private message.
     *
     * `HTTP.POST /private_message`
     */
    LemmyHttp.prototype.createPrivateMessage = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Post, "/private_message", form, person_1.PrivateMessageResponse)];
            });
        });
    };
    /**
     * Edit a private message.
     *
     * `HTTP.PUT /private_message`
     */
    LemmyHttp.prototype.editPrivateMessage = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Put, "/private_message", form, person_1.PrivateMessageResponse)];
            });
        });
    };
    /**
     * Delete a private message.
     *
     * `HTTP.POST /private_message/delete`
     */
    LemmyHttp.prototype.deletePrivateMessage = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Post, "/private_message/delete", form, person_1.PrivateMessageResponse)];
            });
        });
    };
    /**
     * Mark a private message as read.
     *
     * `HTTP.POST /private_message/mark_as_read`
     */
    LemmyHttp.prototype.markPrivateMessageAsRead = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Post, "/private_message/mark_as_read", form, person_1.PrivateMessageResponse)];
            });
        });
    };
    /**
     * Register a new user.
     *
     * `HTTP.POST /user/register`
     */
    LemmyHttp.prototype.register = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Post, "/user/register", form, person_1.LoginResponse)];
            });
        });
    };
    /**
     * Log into lemmy.
     *
     * `HTTP.POST /user/login`
     */
    LemmyHttp.prototype.login = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Post, "/user/login", form, person_1.LoginResponse)];
            });
        });
    };
    /**
     * Get the details for a person.
     *
     * `HTTP.GET /user`
     */
    LemmyHttp.prototype.getPersonDetails = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Get, "/user", form, person_1.GetPersonDetailsResponse)];
            });
        });
    };
    /**
     * Get mentions for your user.
     *
     * `HTTP.GET /user/mention`
     */
    LemmyHttp.prototype.getPersonMentions = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Get, "/user/mention", form, person_1.GetPersonMentionsResponse)];
            });
        });
    };
    /**
     * Mark a person mention as read.
     *
     * `HTTP.POST /user/mention/mark_as_read`
     */
    LemmyHttp.prototype.markPersonMentionAsRead = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Post, "/user/mention/mark_as_read", form, person_1.PersonMentionResponse)];
            });
        });
    };
    /**
     * Get comment replies.
     *
     * `HTTP.GET /user/replies`
     */
    LemmyHttp.prototype.getReplies = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Get, "/user/replies", form, person_1.GetRepliesResponse)];
            });
        });
    };
    /**
     * Ban a person from your site.
     *
     * `HTTP.POST /user/ban`
     */
    LemmyHttp.prototype.banPerson = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Post, "/user/ban", form, person_1.BanPersonResponse)];
            });
        });
    };
    /**
     * Get a list of banned users
     *
     * `HTTP.GET /user/banned`
     */
    LemmyHttp.prototype.getBannedPersons = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Get, "/user/banned", form, person_1.BannedPersonsResponse)];
            });
        });
    };
    /**
     * Block a person.
     *
     * `HTTP.POST /user/block`
     */
    LemmyHttp.prototype.blockPerson = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Post, "/user/block", form, person_1.BlockPersonResponse)];
            });
        });
    };
    /**
     * Fetch a Captcha.
     *
     * `HTTP.GET /user/get_captcha`
     */
    LemmyHttp.prototype.getCaptcha = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Get, "/user/get_captcha", {}, person_1.GetCaptchaResponse)];
            });
        });
    };
    /**
     * Delete your account.
     *
     * `HTTP.POST /user/delete_account`
     */
    LemmyHttp.prototype.deleteAccount = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Post, "/user/delete_account", form, person_1.DeleteAccountResponse)];
            });
        });
    };
    /**
     * Reset your password.
     *
     * `HTTP.POST /user/password_reset`
     */
    LemmyHttp.prototype.passwordReset = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Post, "/user/password_reset", form, person_1.PasswordResetResponse)];
            });
        });
    };
    /**
     * Change your password from an email / token based reset.
     *
     * `HTTP.POST /user/password_change`
     */
    LemmyHttp.prototype.passwordChange = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Post, "/user/password_change", form, person_1.LoginResponse)];
            });
        });
    };
    /**
     * Mark all replies as read.
     *
     * `HTTP.POST /user/mark_all_as_read`
     */
    LemmyHttp.prototype.markAllAsRead = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Post, "/user/mark_all_as_read", form, person_1.GetRepliesResponse)];
            });
        });
    };
    /**
     * Save your user settings.
     *
     * `HTTP.PUT /user/save_user_settings`
     */
    LemmyHttp.prototype.saveUserSettings = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Put, "/user/save_user_settings", form, person_1.LoginResponse)];
            });
        });
    };
    /**
     * Change your user password.
     *
     * `HTTP.PUT /user/change_password`
     */
    LemmyHttp.prototype.changePassword = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Put, "/user/change_password", form, person_1.LoginResponse)];
            });
        });
    };
    /**
     * Get counts for your reports
     *
     * `HTTP.GET /user/report_count`
     */
    LemmyHttp.prototype.getReportCount = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Get, "/user/report_count", form, person_1.GetReportCountResponse)];
            });
        });
    };
    /**
     * Get your unread counts
     *
     * `HTTP.GET /user/unread_count`
     */
    LemmyHttp.prototype.getUnreadCount = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Get, "/user/unread_count", form, person_1.GetUnreadCountResponse)];
            });
        });
    };
    /**
     * Verify your email
     *
     * `HTTP.POST /user/verify_email`
     */
    LemmyHttp.prototype.verifyEmail = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Post, "/user/verify_email", form, person_1.VerifyEmailResponse)];
            });
        });
    };
    /**
     * Add an admin to your site.
     *
     * `HTTP.POST /admin/add`
     */
    LemmyHttp.prototype.addAdmin = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Post, "/admin/add", form, person_1.AddAdminResponse)];
            });
        });
    };
    /**
     * Get the unread registration applications count.
     *
     * `HTTP.GET /admin/registration_application/count`
     */
    LemmyHttp.prototype.getUnreadRegistrationApplicationCount = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Get, "/admin/registration_application/count", form, site_1.GetUnreadRegistrationApplicationCountResponse)];
            });
        });
    };
    /**
     * List the registration applications.
     *
     * `HTTP.GET /admin/registration_application/list`
     */
    LemmyHttp.prototype.listRegistrationApplications = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Get, "/admin/registration_application/list", form, site_1.ListRegistrationApplicationsResponse)];
            });
        });
    };
    /**
     * Approve a registration application
     *
     * `HTTP.PUT /admin/registration_application/approve`
     */
    LemmyHttp.prototype.approveRegistrationApplication = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Put, "/admin/registration_application/approve", form, site_1.RegistrationApplicationResponse)];
            });
        });
    };
    /**
     * Purge / Delete a person from the database.
     *
     * `HTTP.POST /admin/purge/person`
     */
    LemmyHttp.prototype.purgePerson = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Post, "/admin/purge/person", form, site_1.PurgeItemResponse)];
            });
        });
    };
    /**
     * Purge / Delete a community from the database.
     *
     * `HTTP.POST /admin/purge/community`
     */
    LemmyHttp.prototype.purgeCommunity = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Post, "/admin/purge/community", form, site_1.PurgeItemResponse)];
            });
        });
    };
    /**
     * Purge / Delete a post from the database.
     *
     * `HTTP.POST /admin/purge/post`
     */
    LemmyHttp.prototype.purgePost = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Post, "/admin/purge/post", form, site_1.PurgeItemResponse)];
            });
        });
    };
    /**
     * Purge / Delete a comment from the database.
     *
     * `HTTP.POST /admin/purge/comment`
     */
    LemmyHttp.prototype.purgeComment = function (form) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.wrapper(HttpType.Post, "/admin/purge/comment", form, site_1.PurgeItemResponse)];
            });
        });
    };
    LemmyHttp.prototype.buildFullUrl = function (endpoint) {
        return "".concat(this.apiUrl).concat(endpoint);
    };
    LemmyHttp.prototype.wrapper = function (type_, endpoint, form, responseClass) {
        return __awaiter(this, void 0, void 0, function () {
            var getUrl;
            return __generator(this, function (_a) {
                if (type_ == HttpType.Get) {
                    getUrl = "".concat(this.buildFullUrl(endpoint), "?").concat(encodeGetParams(form));
                    return [2 /*return*/, fetch(getUrl, {
                            method: "GET",
                            headers: this.headers,
                        })
                            .then(function (response) {
                            if (!response.ok) {
                                var error = new LemmyHttpError("Response returns error");
                                error.response = response;
                                throw error;
                            }
                            return response.text();
                        })
                            .then(function (text) {
                            return (0, class_transformer_1.deserialize)(responseClass, text);
                        })];
                }
                else {
                    return [2 /*return*/, fetch(this.buildFullUrl(endpoint), {
                            method: type_,
                            headers: __assign({ "Content-Type": "application/json" }, this.headers),
                            body: (0, class_transformer_1.serialize)(form),
                        })
                            .then(function (response) {
                            if (!response.ok) {
                                var error = new LemmyHttpError("Response returns error");
                                error.response = response;
                                throw error;
                            }
                            return response.text();
                        })
                            .then(function (text) {
                            return (0, class_transformer_1.deserialize)(responseClass, text);
                        })];
                }
                return [2 /*return*/];
            });
        });
    };
    return LemmyHttp;
}());
exports.LemmyHttp = LemmyHttp;
function encodeGetParams(p) {
    // Necessary to remove the Options
    var serialized = JSON.parse((0, class_transformer_1.serialize)(p));
    return Object.entries(serialized)
        .map(function (kv) { return kv.map(encodeURIComponent).join("="); })
        .join("&");
}
