"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SiteMetadata = exports.SubscribedType = exports.ModlogActionType = exports.SearchType = exports.ListingType = exports.CommentSortType = exports.SortType = exports.UserOperation = exports.VERSION = void 0;
var class_transformer_1 = require("class-transformer");
var utils_1 = require("../utils");
exports.VERSION = "v3";
/**
 * All of the websocket operations available.
 */
var UserOperation;
(function (UserOperation) {
    UserOperation[UserOperation["Login"] = 0] = "Login";
    UserOperation[UserOperation["Register"] = 1] = "Register";
    UserOperation[UserOperation["GetCaptcha"] = 2] = "GetCaptcha";
    UserOperation[UserOperation["CreateCommunity"] = 3] = "CreateCommunity";
    UserOperation[UserOperation["CreatePost"] = 4] = "CreatePost";
    UserOperation[UserOperation["ListCommunities"] = 5] = "ListCommunities";
    UserOperation[UserOperation["GetPost"] = 6] = "GetPost";
    UserOperation[UserOperation["GetCommunity"] = 7] = "GetCommunity";
    UserOperation[UserOperation["CreateComment"] = 8] = "CreateComment";
    UserOperation[UserOperation["EditComment"] = 9] = "EditComment";
    UserOperation[UserOperation["DeleteComment"] = 10] = "DeleteComment";
    UserOperation[UserOperation["RemoveComment"] = 11] = "RemoveComment";
    UserOperation[UserOperation["SaveComment"] = 12] = "SaveComment";
    UserOperation[UserOperation["CreateCommentLike"] = 13] = "CreateCommentLike";
    UserOperation[UserOperation["GetPosts"] = 14] = "GetPosts";
    UserOperation[UserOperation["CreatePostLike"] = 15] = "CreatePostLike";
    UserOperation[UserOperation["EditPost"] = 16] = "EditPost";
    UserOperation[UserOperation["DeletePost"] = 17] = "DeletePost";
    UserOperation[UserOperation["RemovePost"] = 18] = "RemovePost";
    UserOperation[UserOperation["LockPost"] = 19] = "LockPost";
    UserOperation[UserOperation["StickyPost"] = 20] = "StickyPost";
    UserOperation[UserOperation["MarkPostAsRead"] = 21] = "MarkPostAsRead";
    UserOperation[UserOperation["SavePost"] = 22] = "SavePost";
    UserOperation[UserOperation["EditCommunity"] = 23] = "EditCommunity";
    UserOperation[UserOperation["DeleteCommunity"] = 24] = "DeleteCommunity";
    UserOperation[UserOperation["RemoveCommunity"] = 25] = "RemoveCommunity";
    UserOperation[UserOperation["FollowCommunity"] = 26] = "FollowCommunity";
    UserOperation[UserOperation["GetPersonDetails"] = 27] = "GetPersonDetails";
    UserOperation[UserOperation["GetReplies"] = 28] = "GetReplies";
    UserOperation[UserOperation["GetPersonMentions"] = 29] = "GetPersonMentions";
    UserOperation[UserOperation["MarkPersonMentionAsRead"] = 30] = "MarkPersonMentionAsRead";
    UserOperation[UserOperation["MarkCommentReplyAsRead"] = 31] = "MarkCommentReplyAsRead";
    UserOperation[UserOperation["GetModlog"] = 32] = "GetModlog";
    UserOperation[UserOperation["BanFromCommunity"] = 33] = "BanFromCommunity";
    UserOperation[UserOperation["AddModToCommunity"] = 34] = "AddModToCommunity";
    UserOperation[UserOperation["CreateSite"] = 35] = "CreateSite";
    UserOperation[UserOperation["EditSite"] = 36] = "EditSite";
    UserOperation[UserOperation["GetSite"] = 37] = "GetSite";
    UserOperation[UserOperation["AddAdmin"] = 38] = "AddAdmin";
    UserOperation[UserOperation["GetUnreadRegistrationApplicationCount"] = 39] = "GetUnreadRegistrationApplicationCount";
    UserOperation[UserOperation["ListRegistrationApplications"] = 40] = "ListRegistrationApplications";
    UserOperation[UserOperation["ApproveRegistrationApplication"] = 41] = "ApproveRegistrationApplication";
    UserOperation[UserOperation["BanPerson"] = 42] = "BanPerson";
    UserOperation[UserOperation["GetBannedPersons"] = 43] = "GetBannedPersons";
    UserOperation[UserOperation["Search"] = 44] = "Search";
    UserOperation[UserOperation["ResolveObject"] = 45] = "ResolveObject";
    UserOperation[UserOperation["MarkAllAsRead"] = 46] = "MarkAllAsRead";
    UserOperation[UserOperation["SaveUserSettings"] = 47] = "SaveUserSettings";
    UserOperation[UserOperation["TransferCommunity"] = 48] = "TransferCommunity";
    UserOperation[UserOperation["LeaveAdmin"] = 49] = "LeaveAdmin";
    UserOperation[UserOperation["DeleteAccount"] = 50] = "DeleteAccount";
    UserOperation[UserOperation["PasswordReset"] = 51] = "PasswordReset";
    UserOperation[UserOperation["PasswordChange"] = 52] = "PasswordChange";
    UserOperation[UserOperation["CreatePrivateMessage"] = 53] = "CreatePrivateMessage";
    UserOperation[UserOperation["EditPrivateMessage"] = 54] = "EditPrivateMessage";
    UserOperation[UserOperation["DeletePrivateMessage"] = 55] = "DeletePrivateMessage";
    UserOperation[UserOperation["MarkPrivateMessageAsRead"] = 56] = "MarkPrivateMessageAsRead";
    UserOperation[UserOperation["GetPrivateMessages"] = 57] = "GetPrivateMessages";
    UserOperation[UserOperation["UserJoin"] = 58] = "UserJoin";
    UserOperation[UserOperation["GetComments"] = 59] = "GetComments";
    UserOperation[UserOperation["PostJoin"] = 60] = "PostJoin";
    UserOperation[UserOperation["CommunityJoin"] = 61] = "CommunityJoin";
    UserOperation[UserOperation["ChangePassword"] = 62] = "ChangePassword";
    UserOperation[UserOperation["GetSiteMetadata"] = 63] = "GetSiteMetadata";
    UserOperation[UserOperation["BlockCommunity"] = 64] = "BlockCommunity";
    UserOperation[UserOperation["BlockPerson"] = 65] = "BlockPerson";
    UserOperation[UserOperation["PurgePerson"] = 66] = "PurgePerson";
    UserOperation[UserOperation["PurgeCommunity"] = 67] = "PurgeCommunity";
    UserOperation[UserOperation["PurgePost"] = 68] = "PurgePost";
    UserOperation[UserOperation["PurgeComment"] = 69] = "PurgeComment";
    UserOperation[UserOperation["CreateCommentReport"] = 70] = "CreateCommentReport";
    UserOperation[UserOperation["ResolveCommentReport"] = 71] = "ResolveCommentReport";
    UserOperation[UserOperation["ListCommentReports"] = 72] = "ListCommentReports";
    UserOperation[UserOperation["CreatePostReport"] = 73] = "CreatePostReport";
    UserOperation[UserOperation["ResolvePostReport"] = 74] = "ResolvePostReport";
    UserOperation[UserOperation["ListPostReports"] = 75] = "ListPostReports";
    UserOperation[UserOperation["GetReportCount"] = 76] = "GetReportCount";
    UserOperation[UserOperation["GetUnreadCount"] = 77] = "GetUnreadCount";
    UserOperation[UserOperation["VerifyEmail"] = 78] = "VerifyEmail";
})(UserOperation = exports.UserOperation || (exports.UserOperation = {}));
/**
 * Different post sort types used in lemmy.
 */
var SortType;
(function (SortType) {
    /**
     * Posts sorted by hot, but bumped by new comments up to 2 days
     */
    SortType["Active"] = "Active";
    /**
     * Posts sorted by a decaying rank.
     */
    SortType["Hot"] = "Hot";
    /**
     * Posts sorted by the published time.
     */
    SortType["New"] = "New";
    /**
     * Posts sorted by the published time ascending
     */
    SortType["Old"] = "Old";
    /**
     * The top posts for this last day.
     */
    SortType["TopDay"] = "TopDay";
    /**
     * The top posts for this last week.
     */
    SortType["TopWeek"] = "TopWeek";
    /**
     * The top posts for this last month.
     */
    SortType["TopMonth"] = "TopMonth";
    /**
     * The top posts for this last year.
     */
    SortType["TopYear"] = "TopYear";
    /**
     * The top posts of all time.
     */
    SortType["TopAll"] = "TopAll";
    /**
     * Posts sorted by the most comments.
     */
    SortType["MostComments"] = "MostComments";
    /**
     * Posts sorted by the newest comments, with no necrobumping. IE a forum sort.
     */
    SortType["NewComments"] = "NewComments";
})(SortType = exports.SortType || (exports.SortType = {}));
/**
 * Different comment sort types used in lemmy.
 */
var CommentSortType;
(function (CommentSortType) {
    /**
     * Comments sorted by a decaying rank.
     */
    CommentSortType["Hot"] = "Hot";
    /**
     * Comments sorted by top score.
     */
    CommentSortType["Top"] = "Top";
    /**
     * Comments sorted by new.
     */
    CommentSortType["New"] = "New";
    /**
     * Comments sorted by old.
     */
    CommentSortType["Old"] = "Old";
})(CommentSortType = exports.CommentSortType || (exports.CommentSortType = {}));
/**
 * The different listing types for post and comment fetches.
 */
var ListingType;
(function (ListingType) {
    ListingType["All"] = "All";
    ListingType["Local"] = "Local";
    ListingType["Subscribed"] = "Subscribed";
    ListingType["Community"] = "Community";
})(ListingType = exports.ListingType || (exports.ListingType = {}));
/**
 * Search types for lemmy's search.
 */
var SearchType;
(function (SearchType) {
    SearchType["All"] = "All";
    SearchType["Comments"] = "Comments";
    SearchType["Posts"] = "Posts";
    SearchType["Communities"] = "Communities";
    SearchType["Users"] = "Users";
    SearchType["Url"] = "Url";
})(SearchType = exports.SearchType || (exports.SearchType = {}));
/**
 * Mod log action types
 */
var ModlogActionType;
(function (ModlogActionType) {
    ModlogActionType["All"] = "All";
    ModlogActionType["ModRemovePost"] = "ModRemovePost";
    ModlogActionType["ModLockPost"] = "ModLockPost";
    ModlogActionType["ModStickyPost"] = "ModStickyPost";
    ModlogActionType["ModRemoveComment"] = "ModRemoveComment";
    ModlogActionType["ModRemoveCommunity"] = "ModRemoveCommunity";
    ModlogActionType["ModBanFromCommunity"] = "ModBanFromCommunity";
    ModlogActionType["ModAddCommunity"] = "ModAddCommunity";
    ModlogActionType["ModTransferCommunity"] = "ModTransferCommunity";
    ModlogActionType["ModAdd"] = "ModAdd";
    ModlogActionType["ModBan"] = "ModBan";
    ModlogActionType["ModHideCommunity"] = "ModHideCommunity";
    ModlogActionType["AdminPurgePerson"] = "AdminPurgePerson";
    ModlogActionType["AdminPurgeCommunity"] = "AdminPurgeCommunity";
    ModlogActionType["AdminPurgePost"] = "AdminPurgePost";
    ModlogActionType["AdminPurgeComment"] = "AdminPurgeComment";
})(ModlogActionType = exports.ModlogActionType || (exports.ModlogActionType = {}));
/**
 * Different Subscribed states
 */
var SubscribedType;
(function (SubscribedType) {
    SubscribedType["Subscribed"] = "Subscribed";
    SubscribedType["NotSubscribed"] = "NotSubscribed";
    SubscribedType["Pending"] = "Pending";
})(SubscribedType = exports.SubscribedType || (exports.SubscribedType = {}));
/**
 * A holder for a site's metadata ( such as opengraph tags ), used for post links.
 */
var SiteMetadata = /** @class */ (function () {
    function SiteMetadata(init) {
        Object.assign(this, init);
    }
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], SiteMetadata.prototype, "title", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], SiteMetadata.prototype, "description", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], SiteMetadata.prototype, "image", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], SiteMetadata.prototype, "html", void 0);
    return SiteMetadata;
}());
exports.SiteMetadata = SiteMetadata;
