"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.RegistrationApplicationView = exports.CommunityView = exports.PersonBlockView = exports.CommunityPersonBanView = exports.CommunityModeratorView = exports.CommunityBlockView = exports.CommunityFollowerView = exports.AdminPurgeCommentView = exports.AdminPurgePostView = exports.AdminPurgePersonView = exports.AdminPurgeCommunityView = exports.ModStickyPostView = exports.ModRemovePostView = exports.ModRemoveCommunityView = exports.ModRemoveCommentView = exports.ModLockPostView = exports.ModBanView = exports.ModBanFromCommunityView = exports.ModAddView = exports.ModTransferCommunityView = exports.ModAddCommunityView = exports.CommentReportView = exports.CommentReplyView = exports.CommentView = exports.PostReportView = exports.PostView = exports.PrivateMessageView = exports.SiteView = exports.LocalUserSettingsView = exports.PersonMentionView = exports.PersonViewSafe = void 0;
var class_transformer_1 = require("class-transformer");
require("reflect-metadata");
var utils_1 = require("../utils");
var source_1 = require("./source");
var PersonViewSafe = /** @class */ (function () {
    function PersonViewSafe() {
    }
    __decorate([
        (0, class_transformer_1.Type)(function () { return source_1.PersonSafe; })
    ], PersonViewSafe.prototype, "person", void 0);
    return PersonViewSafe;
}());
exports.PersonViewSafe = PersonViewSafe;
var PersonMentionView = /** @class */ (function () {
    function PersonMentionView() {
    }
    __decorate([
        (0, class_transformer_1.Type)(function () { return source_1.PersonMention; })
    ], PersonMentionView.prototype, "person_mention", void 0);
    __decorate([
        (0, class_transformer_1.Type)(function () { return source_1.Comment; })
    ], PersonMentionView.prototype, "comment", void 0);
    __decorate([
        (0, class_transformer_1.Type)(function () { return source_1.PersonSafe; })
    ], PersonMentionView.prototype, "creator", void 0);
    __decorate([
        (0, class_transformer_1.Type)(function () { return source_1.Post; })
    ], PersonMentionView.prototype, "post", void 0);
    __decorate([
        (0, class_transformer_1.Type)(function () { return source_1.CommunitySafe; })
    ], PersonMentionView.prototype, "community", void 0);
    __decorate([
        (0, class_transformer_1.Type)(function () { return source_1.PersonSafe; })
    ], PersonMentionView.prototype, "recipient", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], PersonMentionView.prototype, "my_vote", void 0);
    return PersonMentionView;
}());
exports.PersonMentionView = PersonMentionView;
var LocalUserSettingsView = /** @class */ (function () {
    function LocalUserSettingsView() {
    }
    __decorate([
        (0, class_transformer_1.Type)(function () { return source_1.LocalUserSettings; })
    ], LocalUserSettingsView.prototype, "local_user", void 0);
    __decorate([
        (0, class_transformer_1.Type)(function () { return source_1.PersonSafe; })
    ], LocalUserSettingsView.prototype, "person", void 0);
    return LocalUserSettingsView;
}());
exports.LocalUserSettingsView = LocalUserSettingsView;
var SiteView = /** @class */ (function () {
    function SiteView() {
    }
    __decorate([
        (0, class_transformer_1.Type)(function () { return source_1.Site; })
    ], SiteView.prototype, "site", void 0);
    return SiteView;
}());
exports.SiteView = SiteView;
var PrivateMessageView = /** @class */ (function () {
    function PrivateMessageView() {
    }
    __decorate([
        (0, class_transformer_1.Type)(function () { return source_1.PrivateMessage; })
    ], PrivateMessageView.prototype, "private_message", void 0);
    __decorate([
        (0, class_transformer_1.Type)(function () { return source_1.PersonSafe; })
    ], PrivateMessageView.prototype, "creator", void 0);
    __decorate([
        (0, class_transformer_1.Type)(function () { return source_1.PersonSafe; })
    ], PrivateMessageView.prototype, "recipient", void 0);
    return PrivateMessageView;
}());
exports.PrivateMessageView = PrivateMessageView;
var PostView = /** @class */ (function () {
    function PostView() {
    }
    __decorate([
        (0, class_transformer_1.Type)(function () { return source_1.Post; })
    ], PostView.prototype, "post", void 0);
    __decorate([
        (0, class_transformer_1.Type)(function () { return source_1.PersonSafe; })
    ], PostView.prototype, "creator", void 0);
    __decorate([
        (0, class_transformer_1.Type)(function () { return source_1.CommunitySafe; })
    ], PostView.prototype, "community", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], PostView.prototype, "my_vote", void 0);
    return PostView;
}());
exports.PostView = PostView;
var PostReportView = /** @class */ (function () {
    function PostReportView() {
    }
    __decorate([
        (0, class_transformer_1.Type)(function () { return source_1.PostReport; })
    ], PostReportView.prototype, "post_report", void 0);
    __decorate([
        (0, class_transformer_1.Type)(function () { return source_1.Post; })
    ], PostReportView.prototype, "post", void 0);
    __decorate([
        (0, class_transformer_1.Type)(function () { return source_1.CommunitySafe; })
    ], PostReportView.prototype, "community", void 0);
    __decorate([
        (0, class_transformer_1.Type)(function () { return source_1.PersonSafe; })
    ], PostReportView.prototype, "creator", void 0);
    __decorate([
        (0, class_transformer_1.Type)(function () { return source_1.PersonSafe; })
    ], PostReportView.prototype, "post_creator", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], PostReportView.prototype, "my_vote", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)(),
        (0, class_transformer_1.Type)(function () { return source_1.PersonSafe; })
    ], PostReportView.prototype, "resolver", void 0);
    return PostReportView;
}());
exports.PostReportView = PostReportView;
var CommentView = /** @class */ (function () {
    function CommentView() {
    }
    __decorate([
        (0, class_transformer_1.Type)(function () { return source_1.Comment; })
    ], CommentView.prototype, "comment", void 0);
    __decorate([
        (0, class_transformer_1.Type)(function () { return source_1.PersonSafe; })
    ], CommentView.prototype, "creator", void 0);
    __decorate([
        (0, class_transformer_1.Type)(function () { return source_1.Post; })
    ], CommentView.prototype, "post", void 0);
    __decorate([
        (0, class_transformer_1.Type)(function () { return source_1.CommunitySafe; })
    ], CommentView.prototype, "community", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], CommentView.prototype, "my_vote", void 0);
    return CommentView;
}());
exports.CommentView = CommentView;
var CommentReplyView = /** @class */ (function () {
    function CommentReplyView() {
    }
    __decorate([
        (0, class_transformer_1.Type)(function () { return source_1.CommentReply; })
    ], CommentReplyView.prototype, "comment_reply", void 0);
    __decorate([
        (0, class_transformer_1.Type)(function () { return source_1.Comment; })
    ], CommentReplyView.prototype, "comment", void 0);
    __decorate([
        (0, class_transformer_1.Type)(function () { return source_1.PersonSafe; })
    ], CommentReplyView.prototype, "creator", void 0);
    __decorate([
        (0, class_transformer_1.Type)(function () { return source_1.Post; })
    ], CommentReplyView.prototype, "post", void 0);
    __decorate([
        (0, class_transformer_1.Type)(function () { return source_1.CommunitySafe; })
    ], CommentReplyView.prototype, "community", void 0);
    __decorate([
        (0, class_transformer_1.Type)(function () { return source_1.PersonSafe; })
    ], CommentReplyView.prototype, "recipient", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], CommentReplyView.prototype, "my_vote", void 0);
    return CommentReplyView;
}());
exports.CommentReplyView = CommentReplyView;
var CommentReportView = /** @class */ (function () {
    function CommentReportView() {
    }
    __decorate([
        (0, class_transformer_1.Type)(function () { return source_1.CommentReport; })
    ], CommentReportView.prototype, "comment_report", void 0);
    __decorate([
        (0, class_transformer_1.Type)(function () { return source_1.Comment; })
    ], CommentReportView.prototype, "comment", void 0);
    __decorate([
        (0, class_transformer_1.Type)(function () { return source_1.Post; })
    ], CommentReportView.prototype, "post", void 0);
    __decorate([
        (0, class_transformer_1.Type)(function () { return source_1.CommunitySafe; })
    ], CommentReportView.prototype, "community", void 0);
    __decorate([
        (0, class_transformer_1.Type)(function () { return source_1.PersonSafe; })
    ], CommentReportView.prototype, "creator", void 0);
    __decorate([
        (0, class_transformer_1.Type)(function () { return source_1.PersonSafe; })
    ], CommentReportView.prototype, "comment_creator", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)()
    ], CommentReportView.prototype, "my_vote", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)(),
        (0, class_transformer_1.Type)(function () { return source_1.PersonSafe; })
    ], CommentReportView.prototype, "resolver", void 0);
    return CommentReportView;
}());
exports.CommentReportView = CommentReportView;
var ModAddCommunityView = /** @class */ (function () {
    function ModAddCommunityView() {
    }
    __decorate([
        (0, class_transformer_1.Type)(function () { return source_1.ModAddCommunity; })
    ], ModAddCommunityView.prototype, "mod_add_community", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)(),
        (0, class_transformer_1.Type)(function () { return source_1.PersonSafe; })
    ], ModAddCommunityView.prototype, "moderator", void 0);
    __decorate([
        (0, class_transformer_1.Type)(function () { return source_1.CommunitySafe; })
    ], ModAddCommunityView.prototype, "community", void 0);
    __decorate([
        (0, class_transformer_1.Type)(function () { return source_1.PersonSafe; })
    ], ModAddCommunityView.prototype, "modded_person", void 0);
    return ModAddCommunityView;
}());
exports.ModAddCommunityView = ModAddCommunityView;
var ModTransferCommunityView = /** @class */ (function () {
    function ModTransferCommunityView() {
    }
    __decorate([
        (0, class_transformer_1.Type)(function () { return source_1.ModTransferCommunity; })
    ], ModTransferCommunityView.prototype, "mod_transfer_community", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)(),
        (0, class_transformer_1.Type)(function () { return source_1.PersonSafe; })
    ], ModTransferCommunityView.prototype, "moderator", void 0);
    __decorate([
        (0, class_transformer_1.Type)(function () { return source_1.CommunitySafe; })
    ], ModTransferCommunityView.prototype, "community", void 0);
    __decorate([
        (0, class_transformer_1.Type)(function () { return source_1.PersonSafe; })
    ], ModTransferCommunityView.prototype, "modded_person", void 0);
    return ModTransferCommunityView;
}());
exports.ModTransferCommunityView = ModTransferCommunityView;
var ModAddView = /** @class */ (function () {
    function ModAddView() {
    }
    __decorate([
        (0, class_transformer_1.Type)(function () { return source_1.ModAdd; })
    ], ModAddView.prototype, "mod_add", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)(),
        (0, class_transformer_1.Type)(function () { return source_1.PersonSafe; })
    ], ModAddView.prototype, "moderator", void 0);
    __decorate([
        (0, class_transformer_1.Type)(function () { return source_1.PersonSafe; })
    ], ModAddView.prototype, "modded_person", void 0);
    return ModAddView;
}());
exports.ModAddView = ModAddView;
var ModBanFromCommunityView = /** @class */ (function () {
    function ModBanFromCommunityView() {
    }
    __decorate([
        (0, class_transformer_1.Type)(function () { return source_1.ModBanFromCommunity; })
    ], ModBanFromCommunityView.prototype, "mod_ban_from_community", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)(),
        (0, class_transformer_1.Type)(function () { return source_1.PersonSafe; })
    ], ModBanFromCommunityView.prototype, "moderator", void 0);
    __decorate([
        (0, class_transformer_1.Type)(function () { return source_1.CommunitySafe; })
    ], ModBanFromCommunityView.prototype, "community", void 0);
    __decorate([
        (0, class_transformer_1.Type)(function () { return source_1.PersonSafe; })
    ], ModBanFromCommunityView.prototype, "banned_person", void 0);
    return ModBanFromCommunityView;
}());
exports.ModBanFromCommunityView = ModBanFromCommunityView;
var ModBanView = /** @class */ (function () {
    function ModBanView() {
    }
    __decorate([
        (0, class_transformer_1.Type)(function () { return source_1.ModBan; })
    ], ModBanView.prototype, "mod_ban", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)(),
        (0, class_transformer_1.Type)(function () { return source_1.PersonSafe; })
    ], ModBanView.prototype, "moderator", void 0);
    __decorate([
        (0, class_transformer_1.Type)(function () { return source_1.PersonSafe; })
    ], ModBanView.prototype, "banned_person", void 0);
    return ModBanView;
}());
exports.ModBanView = ModBanView;
var ModLockPostView = /** @class */ (function () {
    function ModLockPostView() {
    }
    __decorate([
        (0, class_transformer_1.Type)(function () { return source_1.ModLockPost; })
    ], ModLockPostView.prototype, "mod_lock_post", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)(),
        (0, class_transformer_1.Type)(function () { return source_1.PersonSafe; })
    ], ModLockPostView.prototype, "moderator", void 0);
    __decorate([
        (0, class_transformer_1.Type)(function () { return source_1.Post; })
    ], ModLockPostView.prototype, "post", void 0);
    __decorate([
        (0, class_transformer_1.Type)(function () { return source_1.CommunitySafe; })
    ], ModLockPostView.prototype, "community", void 0);
    return ModLockPostView;
}());
exports.ModLockPostView = ModLockPostView;
var ModRemoveCommentView = /** @class */ (function () {
    function ModRemoveCommentView() {
    }
    __decorate([
        (0, class_transformer_1.Type)(function () { return source_1.ModRemoveComment; })
    ], ModRemoveCommentView.prototype, "mod_remove_comment", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)(),
        (0, class_transformer_1.Type)(function () { return source_1.PersonSafe; })
    ], ModRemoveCommentView.prototype, "moderator", void 0);
    __decorate([
        (0, class_transformer_1.Type)(function () { return source_1.Comment; })
    ], ModRemoveCommentView.prototype, "comment", void 0);
    __decorate([
        (0, class_transformer_1.Type)(function () { return source_1.PersonSafe; })
    ], ModRemoveCommentView.prototype, "commenter", void 0);
    __decorate([
        (0, class_transformer_1.Type)(function () { return source_1.Post; })
    ], ModRemoveCommentView.prototype, "post", void 0);
    __decorate([
        (0, class_transformer_1.Type)(function () { return source_1.CommunitySafe; })
    ], ModRemoveCommentView.prototype, "community", void 0);
    return ModRemoveCommentView;
}());
exports.ModRemoveCommentView = ModRemoveCommentView;
var ModRemoveCommunityView = /** @class */ (function () {
    function ModRemoveCommunityView() {
    }
    __decorate([
        (0, class_transformer_1.Type)(function () { return source_1.ModRemoveCommunity; })
    ], ModRemoveCommunityView.prototype, "mod_remove_community", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)(),
        (0, class_transformer_1.Type)(function () { return source_1.PersonSafe; })
    ], ModRemoveCommunityView.prototype, "moderator", void 0);
    __decorate([
        (0, class_transformer_1.Type)(function () { return source_1.CommunitySafe; })
    ], ModRemoveCommunityView.prototype, "community", void 0);
    return ModRemoveCommunityView;
}());
exports.ModRemoveCommunityView = ModRemoveCommunityView;
var ModRemovePostView = /** @class */ (function () {
    function ModRemovePostView() {
    }
    __decorate([
        (0, class_transformer_1.Type)(function () { return source_1.ModRemovePost; })
    ], ModRemovePostView.prototype, "mod_remove_post", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)(),
        (0, class_transformer_1.Type)(function () { return source_1.PersonSafe; })
    ], ModRemovePostView.prototype, "moderator", void 0);
    __decorate([
        (0, class_transformer_1.Type)(function () { return source_1.Post; })
    ], ModRemovePostView.prototype, "post", void 0);
    __decorate([
        (0, class_transformer_1.Type)(function () { return source_1.CommunitySafe; })
    ], ModRemovePostView.prototype, "community", void 0);
    return ModRemovePostView;
}());
exports.ModRemovePostView = ModRemovePostView;
var ModStickyPostView = /** @class */ (function () {
    function ModStickyPostView() {
    }
    __decorate([
        (0, class_transformer_1.Type)(function () { return source_1.ModStickyPost; })
    ], ModStickyPostView.prototype, "mod_sticky_post", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)(),
        (0, class_transformer_1.Type)(function () { return source_1.PersonSafe; })
    ], ModStickyPostView.prototype, "moderator", void 0);
    __decorate([
        (0, class_transformer_1.Type)(function () { return source_1.Post; })
    ], ModStickyPostView.prototype, "post", void 0);
    __decorate([
        (0, class_transformer_1.Type)(function () { return source_1.CommunitySafe; })
    ], ModStickyPostView.prototype, "community", void 0);
    return ModStickyPostView;
}());
exports.ModStickyPostView = ModStickyPostView;
var AdminPurgeCommunityView = /** @class */ (function () {
    function AdminPurgeCommunityView() {
    }
    __decorate([
        (0, class_transformer_1.Type)(function () { return source_1.AdminPurgeCommunity; })
    ], AdminPurgeCommunityView.prototype, "admin_purge_community", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)(),
        (0, class_transformer_1.Type)(function () { return source_1.PersonSafe; })
    ], AdminPurgeCommunityView.prototype, "admin", void 0);
    return AdminPurgeCommunityView;
}());
exports.AdminPurgeCommunityView = AdminPurgeCommunityView;
var AdminPurgePersonView = /** @class */ (function () {
    function AdminPurgePersonView() {
    }
    __decorate([
        (0, class_transformer_1.Type)(function () { return source_1.AdminPurgePerson; })
    ], AdminPurgePersonView.prototype, "admin_purge_person", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)(),
        (0, class_transformer_1.Type)(function () { return source_1.PersonSafe; })
    ], AdminPurgePersonView.prototype, "admin", void 0);
    return AdminPurgePersonView;
}());
exports.AdminPurgePersonView = AdminPurgePersonView;
var AdminPurgePostView = /** @class */ (function () {
    function AdminPurgePostView() {
    }
    __decorate([
        (0, class_transformer_1.Type)(function () { return source_1.AdminPurgePost; })
    ], AdminPurgePostView.prototype, "admin_purge_post", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)(),
        (0, class_transformer_1.Type)(function () { return source_1.PersonSafe; })
    ], AdminPurgePostView.prototype, "admin", void 0);
    __decorate([
        (0, class_transformer_1.Type)(function () { return source_1.CommunitySafe; })
    ], AdminPurgePostView.prototype, "community", void 0);
    return AdminPurgePostView;
}());
exports.AdminPurgePostView = AdminPurgePostView;
var AdminPurgeCommentView = /** @class */ (function () {
    function AdminPurgeCommentView() {
    }
    __decorate([
        (0, class_transformer_1.Type)(function () { return source_1.AdminPurgeComment; })
    ], AdminPurgeCommentView.prototype, "admin_purge_comment", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)(),
        (0, class_transformer_1.Type)(function () { return source_1.PersonSafe; })
    ], AdminPurgeCommentView.prototype, "admin", void 0);
    __decorate([
        (0, class_transformer_1.Type)(function () { return source_1.Post; })
    ], AdminPurgeCommentView.prototype, "post", void 0);
    return AdminPurgeCommentView;
}());
exports.AdminPurgeCommentView = AdminPurgeCommentView;
var CommunityFollowerView = /** @class */ (function () {
    function CommunityFollowerView() {
    }
    __decorate([
        (0, class_transformer_1.Type)(function () { return source_1.CommunitySafe; })
    ], CommunityFollowerView.prototype, "community", void 0);
    __decorate([
        (0, class_transformer_1.Type)(function () { return source_1.PersonSafe; })
    ], CommunityFollowerView.prototype, "follower", void 0);
    return CommunityFollowerView;
}());
exports.CommunityFollowerView = CommunityFollowerView;
var CommunityBlockView = /** @class */ (function () {
    function CommunityBlockView() {
    }
    __decorate([
        (0, class_transformer_1.Type)(function () { return source_1.PersonSafe; })
    ], CommunityBlockView.prototype, "person", void 0);
    __decorate([
        (0, class_transformer_1.Type)(function () { return source_1.CommunitySafe; })
    ], CommunityBlockView.prototype, "community", void 0);
    return CommunityBlockView;
}());
exports.CommunityBlockView = CommunityBlockView;
var CommunityModeratorView = /** @class */ (function () {
    function CommunityModeratorView() {
    }
    __decorate([
        (0, class_transformer_1.Type)(function () { return source_1.CommunitySafe; })
    ], CommunityModeratorView.prototype, "community", void 0);
    __decorate([
        (0, class_transformer_1.Type)(function () { return source_1.PersonSafe; })
    ], CommunityModeratorView.prototype, "moderator", void 0);
    return CommunityModeratorView;
}());
exports.CommunityModeratorView = CommunityModeratorView;
var CommunityPersonBanView = /** @class */ (function () {
    function CommunityPersonBanView() {
    }
    __decorate([
        (0, class_transformer_1.Type)(function () { return source_1.CommunitySafe; })
    ], CommunityPersonBanView.prototype, "community", void 0);
    __decorate([
        (0, class_transformer_1.Type)(function () { return source_1.PersonSafe; })
    ], CommunityPersonBanView.prototype, "person", void 0);
    return CommunityPersonBanView;
}());
exports.CommunityPersonBanView = CommunityPersonBanView;
var PersonBlockView = /** @class */ (function () {
    function PersonBlockView() {
    }
    __decorate([
        (0, class_transformer_1.Type)(function () { return source_1.PersonSafe; })
    ], PersonBlockView.prototype, "person", void 0);
    __decorate([
        (0, class_transformer_1.Type)(function () { return source_1.PersonSafe; })
    ], PersonBlockView.prototype, "target", void 0);
    return PersonBlockView;
}());
exports.PersonBlockView = PersonBlockView;
var CommunityView = /** @class */ (function () {
    function CommunityView() {
    }
    __decorate([
        (0, class_transformer_1.Type)(function () { return source_1.CommunitySafe; })
    ], CommunityView.prototype, "community", void 0);
    return CommunityView;
}());
exports.CommunityView = CommunityView;
var RegistrationApplicationView = /** @class */ (function () {
    function RegistrationApplicationView() {
    }
    __decorate([
        (0, class_transformer_1.Type)(function () { return source_1.RegistrationApplication; })
    ], RegistrationApplicationView.prototype, "registration_application", void 0);
    __decorate([
        (0, class_transformer_1.Type)(function () { return source_1.LocalUserSettings; })
    ], RegistrationApplicationView.prototype, "creator_local_user", void 0);
    __decorate([
        (0, class_transformer_1.Type)(function () { return source_1.PersonSafe; })
    ], RegistrationApplicationView.prototype, "creator", void 0);
    __decorate([
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toOption)(value);
        }, { toClassOnly: true }),
        (0, class_transformer_1.Transform)(function (_a) {
            var value = _a.value;
            return (0, utils_1.toUndefined)(value);
        }, { toPlainOnly: true }),
        (0, class_transformer_1.Expose)(),
        (0, class_transformer_1.Type)(function () { return source_1.PersonSafe; })
    ], RegistrationApplicationView.prototype, "admin", void 0);
    return RegistrationApplicationView;
}());
exports.RegistrationApplicationView = RegistrationApplicationView;
